"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mediafilepicker_common_1 = require("./mediafilepicker.common");
var app = require("tns-core-modules/application/application");
var permissions = require('nativescript-permissions');
var FilePickerBuilder = droidninja.filepicker.FilePickerBuilder;
var FilePickerConst = droidninja.filepicker.FilePickerConst;
var Mediafilepicker = (function (_super) {
    __extends(Mediafilepicker, _super);
    function Mediafilepicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.output = "";
        return _this;
    }
    Mediafilepicker.prototype.startFilePicker = function (params) {
        var activity = app.android.foregroundActivity || app.android.startActivity;
        var t = this;
        var builder = FilePickerBuilder.getInstance();
        var options = params.android;
        options.enableImagePicker ? builder.enableImagePicker(true) : builder.enableImagePicker(false);
        options.enableVideoPicker ? builder.enableVideoPicker(true) : builder.enableVideoPicker(false);
        options.enableDocSupport ? builder.enableDocSupport(true) : builder.enableDocSupport(false);
        options.enableCameraSupport ? builder.enableCameraSupport(true) : builder.enableCameraSupport(false);
        options.showGifs ? builder.showGifs(true) : builder.showGifs(false);
        if (options.mxcount) {
            builder.setMaxCount(options.mxcount);
        }
        if (options.setSelectedFiles) {
            builder.setSelectedFiles(options.setSelectedFiles);
        }
        if (options.setActivityTheme) {
            builder.setActivityTheme(options.setActivityTheme);
        }
        if (options.addFileSupport) {
            builder.addFileSupport(options.addFileSupport.title, options.addFileSupport.type, options.addFileSupport.icon);
        }
        permissions.requestPermission([android.Manifest.permission.CAMERA, android.Manifest.permission.WRITE_EXTERNAL_STORAGE], "Need these permissions to access files")
            .then(function () {
            if (options.pickFile) {
                builder.pickFile(activity);
            }
            else {
                builder.pickPhoto(activity);
            }
        })
            .catch(function () {
            alert("Need permission to access files!");
            t.notify({
                eventName: "error",
                object: t,
                data: "Need permission to access files!"
            });
        });
        activity.onActivityResult = function (requestCode, resultCode, data) {
            var androidAcivity = android.app.Activity;
            switch (requestCode) {
                case FilePickerConst.REQUEST_CODE_PHOTO:
                    if (resultCode == androidAcivity.RESULT_OK && data != null) {
                        var photoPaths = data.getStringArrayListExtra(FilePickerConst.KEY_SELECTED_MEDIA);
                        photoPaths = photoPaths.toString();
                        photoPaths = photoPaths.replace(/[\[\]']+/g, "");
                        photoPaths = photoPaths.split(",");
                        photoPaths.forEach(function (val) {
                            var newVal = val.replace(/^\s+/g, '');
                            t.output = newVal + "," + t.output;
                        });
                        t.notify({
                            eventName: "getFiles",
                            object: t,
                            files: t.output.replace(/\,+$/, "")
                        });
                    }
                    break;
                case FilePickerConst.REQUEST_CODE_DOC:
                    if (resultCode == androidAcivity.RESULT_OK && data != null) {
                        var docPaths = data.getStringArrayListExtra(FilePickerConst.KEY_SELECTED_DOCS);
                        docPaths = docPaths.toString();
                        docPaths = docPaths.replace(/[\[\]']+/g, "");
                        docPaths = docPaths.split(",");
                        docPaths.forEach(function (val) {
                            var newVal = val.replace(/^\s+/g, '');
                            t.output = newVal + "," + t.output;
                        });
                        t.notify({
                            eventName: "getFiles",
                            object: t,
                            files: t.output.replace(/\,+$/, "")
                        });
                    }
                    break;
            }
        };
    };
    return Mediafilepicker;
}(mediafilepicker_common_1.Common));
exports.Mediafilepicker = Mediafilepicker;
//# sourceMappingURL=mediafilepicker.android.js.map